import { ReactNode } from 'react';
import { EqualityChecker, State, StateSelector, StoreApi } from 'zustand';
interface UseContextStore<S extends StoreApi<State>> {
    (): ExtractState<S>;
    <U>(selector: StateSelector<ExtractState<S>, U>, equalityFn?: EqualityChecker<U>): U;
}
declare type ExtractState<S> = S extends {
    getState: () => infer T;
} ? T : never;
declare type WithoutCallSignature<T> = {
    [K in keyof T]: T[K];
};
declare function createContext<S extends StoreApi<State>>(): {
    Provider: ({ createStore, children, }: {
        createStore: () => S;
        children: ReactNode;
    }) => import("react").FunctionComponentElement<import("react").ProviderProps<S | undefined>>;
    useStore: UseContextStore<S>;
    useStoreApi: () => WithoutCallSignature<S>;
};
export default createContext;
